//
//  YKLookApplet
//
//  Copyright (c) 2009-2010 YorozuKotowariYa Ltd.
//
//
package jp.co.yorozukotowariya.yklook;

import java.io.*;
import java.net.*;
import java.awt.*;
import javax.swing.*;


public class YKLookApplet extends JApplet implements YKLookCommonIF
{
	static final String ykvMessageRemote =
							"\u0057\u0065\u0062\u30b5\u30fc\u30d0\u3068\u306e" +
							"\u901a\u4fe1\u4e2d\u3067\u3059\u002e\u002e\u002e";
	String       ykvRemote;
	MediaTracker ykvMediaTracker;
	YKLookCommon ykvCommon;

	public void init()  // override Applet
	{
		String selfId = getParameter( "YKLook_selfId" );
		String userId = getParameter( "YKLook_userId" );
		String border = getParameter( "YKLook_border" );
		String remote = getParameter( "YKLook_remote" );

		ykvMediaTracker = new MediaTracker( this );

		ykvCommon = new YKLookCommon( selfId, userId, this );
		ykvCommon.ykmSetEncoding();
		ykvCommon.ykmSetLookAndFeel();

		ykvRemote = ykvCommon.ykmEncodingFrom(
									YKLookCommon.ykmDecodeFromHex( remote ) );
		if( ykvRemote == null )
			ykvRemote = ykvMessageRemote;
		if( ykvRemote.length() < 1 )
			ykvRemote = ykvMessageRemote;

		ykvCommon.ykmCorrespond( null );

		if( ykvCommon.ykvObjects.size() <= 0 )
		{
			String inf = getAppletInfo();

			if( inf == null || inf.length() < 1 )
			{
				inf = YKLookInfo.ykmInfo()[0];
			}
			getContentPane().add( new JLabel( inf ) );
		}
		if( ! border.equals( "false" ) )
		{
			((JPanel) getContentPane()).
					setBorder( BorderFactory.createLineBorder( Color.black ) );
		}
		ykvCommon.ykmShowLog();
	}

	public void destroy()  // override Applet
	{
		ykvCommon.ykmRemoveFrameAll();
	}

	public String getAppletInfo()  // override Applet
	{
		String str = getParameter( "YKLook_appletInfo" );
		if( str == null || str.length() <= 0 )
			return YKLookInfo.ykmInfo()[0];

		return ykvCommon.ykmEncodingFrom(
				YKLookCommon.ykmDecodeFromHex( str ) );
	}

	public String ykmGetParameter( String prmKey )   // YKLookCommonIF
	{
		return getParameter( prmKey );
	}

	public URL ykmGetDocumentBase()         // YKLookCommonIF
			throws MalformedURLException
	{
		return getDocumentBase();
	}

	public RootPaneContainer ykmRootPaneContainer()  // YKLookCommonIF
	{
		return this;
	}

	public Image ykmGetImage( URL prmUrl )  // YKLookCommonIF
			throws MalformedURLException
	{
		Image img = getImage( prmUrl );
		//Image img = Toolkit.getDefaultToolkit().getImage( prmUrl );

		ykvMediaTracker.addImage( img, 1 );
		try
		{
			ykvMediaTracker.waitForID(1);
			//ykvMediaTracker.waitForAll();
		}
		catch( InterruptedException ex )
		{
			// nothing
		}
		return img;
	}

	public InputStream ykmGetCodeAsStream( String prmPath )  // YKLookCommonIF
			throws IOException, YKLookException
	{
		URL    url;
		String str = getParameter( "YKLook_relPath" );

		if( str != null && str.length() > 0 )
			prmPath = str + "/" + prmPath;

		url = new URL( getCodeBase(), prmPath );

		return url.openConnection().getInputStream();
	}

	public String ykmCommunicate( String prmText )  // YKLookCommonIF
			throws IOException, YKLookException
	{
		String             cgi = getParameter( "YKLook_script" );
		URL                url = new URL( getDocumentBase(), cgi );
		URLConnection      uc;
		OutputStream       os;
		OutputStreamWriter osw;
		BufferedWriter     bw;
		InputStream        is;
		InputStreamReader  isr;
		BufferedReader     br;
		String             ans;
		//HttpURLConnection ht;

		showStatus( ykvRemote );

		uc = url.openConnection();
		uc.setDoOutput( true );
		uc.setUseCaches( false );
		//ht = (HttpURLConnection) uc
		//ht.setRequestMethod("POST");
		//uc.connect();

		os  = uc.getOutputStream();
		osw = new OutputStreamWriter( os );
		bw  = new BufferedWriter( osw );

		bw.write( prmText );

		bw .close();
		osw.close();
		os .close();

		is  = uc.getInputStream();
		isr = new InputStreamReader( is );
		br  = new BufferedReader( isr );

		//int cd = ht.getResponseCode(); // 200: ok
		//String msg = ht.getResponseMessage(); // or null
		//uc.getContentLength();  // also -1

		ans = ykvCommon.ykmRecvAnswer( br );

		br .close();
		isr.close();
		is .close();
		//ht.disconnect();

		showStatus( "" );

		return ans;
	}

	public void yk_nextDisplay( String prmPath, String prmOpt )
			throws MalformedURLException, YKLookException     // YKLookCommonIF
	{
		URL url = new URL( getDocumentBase(), prmPath + prmOpt );

		getAppletContext().showDocument( url );
	}
	public void yk_moreDisplay( String prmPath, String prmOpt )
			throws MalformedURLException, YKLookException     // YKLookCommonIF
	{
		URL url = new URL( getDocumentBase(), prmPath + prmOpt );

		getAppletContext().showDocument( url, "_blank" );
	}

	public void yk_showDocument( String prmUrl,String prmFile,String prmTarget )
			throws MalformedURLException, YKLookException     // YKLookCommonIF
	{
		URL url;

		if( prmUrl.length() > 0 )
			url = new URL( prmUrl );
		else
			url = getDocumentBase();

		if( prmFile.length() > 0 )
			url = new URL( url, prmFile );

		if( prmTarget == null )
			getAppletContext().showDocument( url );
		else
			getAppletContext().showDocument( url, prmTarget );
	}

	public void yk_exit( String prmMsg )  // YKLookCommonIF
			throws YKLookException
	{
		JOptionPane.showMessageDialog( null, prmMsg );
		ykvCommon.ykmRemoveFrameAll();
		getContentPane().removeAll();
		getContentPane().repaint();
	}
}


//
// end of program
//
