//
//  YKLookBorder
//  YKLookBorderTitled
//  YKLookBorderCompound
//
//  Copyright (c) 2009-2010 YorozuKotowariYa Ltd.
//
//
package jp.co.yorozukotowariya.yklook;

import java.util.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;


class YKLookBorder extends YKLookSwingBase
{
	Border ykvSelf;

	public boolean yk_createSoftBevelBorder( StringTokenizer prmStrTok )
	{
		return ykmBevel( prmStrTok, true );
	}
	public boolean yk_createBevelBorder( StringTokenizer prmStrTok )
	{
		return ykmBevel( prmStrTok, false );
	}
	public boolean ykmBevel( StringTokenizer prmStrTok, boolean prmSoft )
	{
		String tok = prmStrTok.nextToken();
		Color  c1, c2, c3, c4;
		int    typ;

		switch( tok.charAt(0) )
		{
			case 'L':
			case 'l': typ = BevelBorder.LOWERED; break;
			case 'R':
			case 'r':
			default : typ = BevelBorder.RAISED; break;
		}
		tok = prmStrTok.nextToken();
		if( tok.equalsIgnoreCase("end") )
		{
			if( prmSoft ) ykvSelf = new SoftBevelBorder( typ );
			else          ykvSelf = BorderFactory.createBevelBorder( typ );
			return false;  // scan the next command immediately
		}
		c1  = ykvCommon.ykmDecodeColor( tok );
		tok = prmStrTok.nextToken();
		c2  = ykvCommon.ykmDecodeColor( tok );
		tok = prmStrTok.nextToken();
		if( tok.equalsIgnoreCase("end") )
		{
			if( prmSoft ) ykvSelf = new SoftBevelBorder( typ, c1, c2 );
			else          ykvSelf = BorderFactory.createBevelBorder(typ,c1,c2);
			return false;  // scan the next command immediately
		}
		c3  = ykvCommon.ykmDecodeColor( tok );
		tok = prmStrTok.nextToken();
		c4  = ykvCommon.ykmDecodeColor( tok );
		if( prmSoft )
			ykvSelf = new SoftBevelBorder( typ, c1, c2, c3, c4 );
		else
			ykvSelf = BorderFactory.createBevelBorder( typ, c1, c2, c3, c4 );

		return true;  // need scan for 'end'
	}
	public boolean yk_createEmptyBorder( StringTokenizer prmStrTok )
	{
		int top = Integer.parseInt( prmStrTok.nextToken() );
		int lef = Integer.parseInt( prmStrTok.nextToken() );
		int bot = Integer.parseInt( prmStrTok.nextToken() );
		int rig = Integer.parseInt( prmStrTok.nextToken() );

		ykvSelf = BorderFactory.createEmptyBorder( top, lef, bot, rig );
		return true;  // need scan for 'end'
	}
	public boolean yk_createEtchedBorder( StringTokenizer prmStrTok )
	{
		String tok = prmStrTok.nextToken();
		Color  c1, c2;
		int    typ;

		if( tok.equalsIgnoreCase("end") )
		{
			ykvSelf = BorderFactory.createEtchedBorder();
			return false;  // scan the next command immediately
		}
		switch( tok.charAt(0) )
		{
			case 'G':
			case 'g':
			case 'L':
			case 'l': typ = BevelBorder.LOWERED; break;
			case 'R':
			case 'r':
			default : typ = BevelBorder.RAISED; break;
		}
		tok = prmStrTok.nextToken();
		if( tok.equalsIgnoreCase("end") )
		{
			ykvSelf = BorderFactory.createEtchedBorder( typ );
			return false;  // scan the next command immediately
		}
		c1  = ykvCommon.ykmDecodeColor( tok );
		tok = prmStrTok.nextToken();
		c2  = ykvCommon.ykmDecodeColor( tok );
		ykvSelf = BorderFactory.createEtchedBorder( typ, c1, c2 );
		return true;  // need scan for 'end'
	}
	public boolean yk_createLineBorder( StringTokenizer prmStrTok )
	{
		String tok = prmStrTok.nextToken();
		Color  col = ykvCommon.ykmDecodeColor( tok );
		int    wid;

		tok = prmStrTok.nextToken();
		if( tok.equalsIgnoreCase("end") )
		{
			ykvSelf = BorderFactory.createLineBorder( col );
			return false;  // scan the next command immediately
		}
		wid = Integer.parseInt( tok );
		ykvSelf = BorderFactory.createLineBorder( col, wid );
		return true;  // need scan for 'end'
	}
	public boolean yk_createMatteBorder( StringTokenizer prmStrTok )
	{
		int         top = Integer.parseInt( prmStrTok.nextToken() );
		int         lef = Integer.parseInt( prmStrTok.nextToken() );
		int         bot = Integer.parseInt( prmStrTok.nextToken() );
		int         rig = Integer.parseInt( prmStrTok.nextToken() );
		String      typ = prmStrTok.nextToken();
		String      obj = prmStrTok.nextToken();
		YKLookImage img;
		Color       col;

		if( typ.charAt(0) == 'i' )
		{
			img = (YKLookImage) ykvCommon.ykmFindObjectFromId( obj );
			ykvSelf = BorderFactory.createMatteBorder( top, lef, bot, rig,
														img.ykvSelf );
		}
		else
		{
			col = ykvCommon.ykmDecodeColor( obj );
			ykvSelf = BorderFactory.createMatteBorder( top,lef,bot,rig,col );
		}
		return true;  // need scan for 'end'
	}
}
class YKLookBorderTitled extends YKLookBorder
{
	public boolean yk_createTitledBorder( StringTokenizer prmStrTok )
	{
		String       tok = prmStrTok.nextToken();
		String       ttl = ykvCommon.ykmNextString( prmStrTok );
		YKLookBorder bdr;
		YKLookFont   fon;
		Color        col;
		int          jus, pos;
		TitledBorder tb;

		bdr = (YKLookBorder) ykvCommon.ykmFindObjectFromId( tok );
		ykvSelf = tb = BorderFactory.createTitledBorder( bdr.ykvSelf, ttl );

		tok = prmStrTok.nextToken();
		if( tok.equalsIgnoreCase("end") )
			return false;  // scan the next command immediately

		tok = tok.substring(0,3).toLowerCase();
		for( ;; )
		{
			if( tok.equals("lef") ) { jus = TitledBorder.LEFT    ; break; }
			if( tok.equals("cen") ) { jus = TitledBorder.CENTER  ; break; }
			if( tok.equals("rig") ) { jus = TitledBorder.RIGHT   ; break; }
			if( tok.equals("lea") ) { jus = TitledBorder.LEADING ; break; }
			if( tok.equals("tra") ) { jus = TitledBorder.TRAILING; break; }

			jus = TitledBorder.DEFAULT_JUSTIFICATION;
			break;
		}
		tb.setTitleJustification( jus );

		tok = prmStrTok.nextToken().toLowerCase();
		if( tok.equals("end") )
			return false;  // scan the next command immediately

		for( ;; )
		{
			if( tok.equals("above_top") )
			{ pos = TitledBorder.ABOVE_TOP; break; }
			if( tok.equals("top") )
			{ pos = TitledBorder.TOP; break; }
			if( tok.equals("below_top") )
			{ pos = TitledBorder.BELOW_TOP; break; }
			if( tok.equals("above_bottom") )
			{ pos = TitledBorder.ABOVE_BOTTOM; break; }
			if( tok.equals("bottom") )
			{ pos = TitledBorder.BOTTOM; break; }
			if( tok.equals("below_bottom") )
			{ pos = TitledBorder.BELOW_BOTTOM; break; }

			pos = TitledBorder.DEFAULT_POSITION;
			break;
		}
		tb.setTitlePosition( pos );

		tok = prmStrTok.nextToken().toLowerCase();
		if( tok.equals("end") )
			return false;  // scan the next command immediately

		if( ! tok.equals("null") )
		{
			fon = (YKLookFont) ykvCommon.ykmFindObjectFromId( tok );
			tb.setTitleFont( fon.ykvSelf );
		}
		tok = prmStrTok.nextToken();
		if( tok.equalsIgnoreCase("end") )
			return false;  // scan the next command immediately

		col = ykvCommon.ykmDecodeColor( tok );
		tb.setTitleColor( col );
		return true;  // need scan for 'end'
	}
}
class YKLookBorderCompound extends YKLookBorder
{
	public boolean yk_createCompoundBorder( StringTokenizer prmStrTok )
	{
		String       tok1 = prmStrTok.nextToken();
		String       tok2 = prmStrTok.nextToken();
		YKLookBorder outer, inner;

		outer = (YKLookBorder) ykvCommon.ykmFindObjectFromId( tok1 );
		inner = (YKLookBorder) ykvCommon.ykmFindObjectFromId( tok2 );

		ykvSelf = BorderFactory.createCompoundBorder( outer.ykvSelf,
														inner.ykvSelf );
		return true;  // need scan for 'end'
	}
}

//
// end of program
//
